package MpmasActivityInfo;

use strict;
use warnings;
use Exporter;
use Storable qw(dclone);
use Data::Dumper;
use MpmasInputfile;
use MpmasInputBlock;
our @ISA = qw(MpmasInputfile);

sub filename {
	return "ActivityInfo";
}
sub extension {
	return ".txt";
}
sub leftmargin {
	return "";
}

sub prepare_special {
	my $self = shift;

	my $ainfo = MpmasInputBlock->new(0,100);
	my @SortedActivityGroupings = sort{$a cmp $b} keys %{$self->config_entry("Groupings")->{activity}}; 
	 $ainfo->add_row("Column","Code","Name","OutfileCol", "MpmasqlType", "Account", @SortedActivityGroupings);
	for my $k ($self->sorted_activities) {
		my $i = $self->activity($k);
		my $col = $i->lp_column + 15;
		my @temp = ($i->lp_column,$i->id,$i->attr("name"),"$col", $i->attr("type"), $i->attr("account"));	
		for my $j (@SortedActivityGroupings) {				
			my $group = -1;
			$group = $i->get_group($j) if (defined $i->get_group($j));
			push @temp, $group;
		}
		$ainfo->add_row(@temp);
	}
	$self->add_block($ainfo);

}
1;
