package MpmasConstraintInfo;

use strict;
use warnings;
use Exporter;
use Storable qw(dclone);
use Data::Dumper;
use MpmasInputfile;
use MpmasInputBlock;
our @ISA = qw(MpmasInputfile);

sub filename {
	return "ConstraintInfo";
}

sub extension {
	return ".txt";
}
sub leftmargin {
	return "";
}
sub prepare_special {
	my $self = shift;
	my $cinfo = MpmasInputBlock->new(0,10);
	
	my @SortedConstraintGroupings = sort{$a cmp $b} keys %{$self->config_entry("Groupings")->{constraint}};
	$cinfo->add_row("Row","Code","Name","OutfileCol","MpmasqlType", @SortedConstraintGroupings);
	for my $k ($self->sorted_constraints) {
		my $i = $self->constraint($k);
		my $row = $i->lp_row + 15;
		my @temp = ( $i->lp_row, $i->id, $i->attr("name"), $row,  $i->attr("type"));	
		for my $j (@SortedConstraintGroupings) {				
			my $group = -1;
			$group = $i->get_group($j) if (defined $i->get_group($j) );
			push @temp, "$group";
		}
		$cinfo->add_row(@temp);
	}
	$self->add_block($cinfo);

}
1;
