package MpmasInputBlock;

use strict;
use warnings;
use Exporter;
use Storable qw(dclone);
use Data::Dumper;
use SimpleObject;
our @ISA = qw(SimpleObject);

sub new {
	my $class = shift;
	my @temp = @_;
	my $self = {};
	$self->{commentary_columns} = shift @temp;
	$self->{priority} =  shift @temp;
	$self->{Rows} = [];
	$self->{Comment_Rows} = {};
	$self->{CommentOnly_Rows} = {};
	$self->{NonComment_Rows} = {};
	$self->{NonCommentOnly_Rows} = {};
	$self->{id} = "N/A";
	bless $self, $class;
	return $self;
}


sub set_priority {
	my ($self, $set) = @_;
	$self->{priority} = $set if (defined $set);
	return $self->{priority};
}
sub priority {
    return $_[0]->{priority};
}

sub commentary_columns {
	return $_[0]->{commentary_columns};
}
sub set_commentary_columns {
	$_[0]->{commentary_columns} = $_[1] if (defined $_[1]);
}

sub add_row {
	my ($self, @row) = @_;
	push @{ $self->{Rows} }, \@row;
}

sub add_comment_row {
	my ($self, @row) = @_;
	push @{ $self->{Rows} }, \@row;
	my $i = $#{ $self->{Rows}};
	$self->{Comment_Rows}->{$i} = 1, ;
}

sub add_commentonly_row {
	my ($self, @row) = @_;
	push @{ $self->{Rows} }, \@row;
	my $i = $#{ $self->{Rows} };
	$self->{CommentOnly_Rows}->{$i} = 1, ;
}
sub add_noncomment_row {
	my ($self, @row) = @_;
	push @{ $self->{Rows} }, \@row;
	my $i = $#{ $self->{Rows} };
	$self->{NonComment_Rows}->{$i} = 1, ;
}
sub add_noncommentonly_row {
	my ($self, @row) = @_;
	push @{ $self->{Rows} }, \@row;
	my $i = $#{ $self->{Rows} };
	$self->{NonCommentOnly_Rows}->{$i} = 1, ;
}
sub add_empty_rows {
	my ($self,$n) = @_;
	for (1..$n) {
		push @{ $self->{Rows} }, [("")];
	}
}
sub add_table {
	my ($self, $arrayref) = @_;
	for my $i (@$arrayref){
		push @{ $self->{Rows} }, $i;
	}
}
sub add_row_at_beginning {
	my ($self, @row) = @_;
	unshift @{ $self->{Rows} }, \@row;
}
sub write {
	#writes prepared InputBlock to specified file skipping specified number of columns if not in DBG mode
	#arguments (filehandle, columns to skip, twodimensional array)

	my ($self, $out, $commentmode, $leftmargin) = @_;
        
	my $i = -1;
	my $s = 0;
	
	unless ($commentmode) {
	    $s = $self->{commentary_columns} ;
	    foreach (1 .. $s) { $leftmargin .=  "\t" } 
	}
	
	
	for my $r ( @{ $self->{Rows} } ) {
		$i++;
		print $out "\n" and next if ( not $commentmode and exists $self->{Comment_Rows}->{$i} );
		print $out "\n" and next if ($commentmode and exists $self->{NonComment_Rows}->{$i} );
		next if ($commentmode and exists $self->{NonCommentOnly_Rows}->{$i} );
		next if ( not $commentmode and exists $self->{CommentOnly_Rows}->{$i} );
		#my $string = $leftmargin;
		
		#for my $c (0..$#{$r}){
		#	if (defined $r->[$c] and ( $c >= $self->{commentary_columns} or $commentmode) ) {
		#		$string .= $r->[$c];
		#		}
		#	$string .= "\t";
		#}
		do { no warnings 'uninitialized';
		print $out $leftmargin . join ("\t", @{$r}[$s..$#{$r}] ). "\n";
		};
	}
}

1;