package MpmasMILPActivity;
use strict;
use warnings;
use Exporter;
use Storable qw(dclone);
use Data::Dumper;
use MpmasQLModelElementAbstract;

our @ISA = qw(MpmasQLModelElementAbstract);

##class variables
sub defaultclass {"activity"};
sub list_of_default_fields { 
	my @array = qw(name unit type integ lbound ubound orow consfix landfix priority pseudo_down pseudo_up account type_of_payment quadratic);
	return \@array;
}
sub list_of_attribute_fields{
	my @array = qw(othermilp othermilp_subelements name description unit type integ lbound ubound orow consfix empty landfix xnproduct xnlink priority pseudo_down pseudo_up LPColumn solution grouping labgrp thiscomp cptype sos sos_position sex account type_of_payment quadratic );
	return \@array;
}
sub list_of_attribute_stubs {
	my @array = qw(orow_);
	return \@array;
}

##specific accessor classes
sub orow {
	my ($self,$year,$milpid) = @_;
	if (defined $year) {		
		return $self->{othermilp}->{$milpid}->{"orow_$year"}  if (defined $milpid and $milpid != MpmasInputfile::DEFBASEMILP() and defined $self->{othermilp}->{$milpid}->{"orow_$year"});
		return $self->{orow_}->{$year};
	}
	else {
		return $self->{othermilp}->{$milpid}->{orow} if (defined $milpid and $milpid != MpmasInputfile::DEFBASEMILP() and defined $self->{othermilp}->{$milpid}->{orow});
		return $self->{orow};
	}
}
sub coeff {
	my ($self,$constraint,$milpid) = @_;
	return $self->{othermilp}->{$milpid}->{$constraint} if (defined $milpid and $milpid != MpmasInputfile::DEFBASEMILP() and defined $self->{othermilp}->{$milpid}->{$constraint});
	return $self->{others}->{$constraint};
}
sub set_coeff {
	my ($self,$constraint,$value, $milpid) = @_;
	if (defined $milpid and $milpid != MpmasInputfile::DEFBASEMILP() and defined $self->{othermilp}->{$milpid}->{$constraint}) {
	    $self->{othermilp}->{$milpid}->{$constraint} = $value ;
	}
	else {
	    $self->{others}->{$constraint} = $value;
	}
}
sub coefficients {
	return keys %{$_[0]->{others}};
}

sub lp_column {
	return $_[0]->{LPColumn};
}
sub set_lp_column {
	$_[0]->{LPColumn} = $_[1];
}
sub empty {
      return $_[0]->{empty};
}
sub set_empty {
      $_[0]->{empty} = $_[1];
}
1;