package MpmasMILPConstraint;
use strict;
use warnings;
use Exporter;
use Storable qw(dclone);
use Data::Dumper;
use MpmasQLModelElementAbstract;

our @ISA = qw(MpmasQLModelElementAbstract);

##class variables

sub defaultclass {"constraint"};
sub list_of_default_fields { 
	my @array = qw(name unit eqtype type value);
	return \@array;
}
sub list_of_attribute_fields{
	my @array = qw(othermilp othermilp_subelements name unit eqtype type value range LPRow labgrp epsilon xnproduct perennialconstraint empty sex);
	return \@array;
}
sub list_of_attribute_stubs {
	my @array = qw();
	return \@array;
}


sub lp_row {
	return $_[0]->{LPRow};
}
sub set_lp_row {
	$_[0]->{LPRow} = $_[1];
}
sub type {
	return $_[0]->{type};
}
sub set_type {
	$_[0]->{type} = $_[1];
}
sub empty {
      return $_[0]->{empty};
}
sub set_empty {
      $_[0]->{empty} = $_[1];
}
sub calculate_attributes {
	my $self = $_[0];
	#determine range from eqtype
	if ($self->attr("eqtype") == 1) {
		$self->{range} = -10**31 unless (defined $self->{range});
		$self->{showsign} = "'<=";
	}
	elsif ($self->attr("eqtype") == 3) {
		$self->{range} = 0 unless (defined $self->{range});
		$self->{showsign} = "'==";
	}
	elsif ($self->attr("eqtype") == 2) {
		$self->{range} = 10**31 unless (defined $self->{range});
		$self->{showsign} = "'>=";
	}
	#same for milps of other agents
	foreach my $m (keys %{$self->{othermilp} }) {
		if ($self->attr("eqtype", $m) != $self->attr("eqtype")) {
			if ($self->attr("eqtype", $m) == 1) {
				$self->{othermilp}->{$m}->{range} = -10**31 unless (defined $self->{othermilp}->{$m}->{range});
				$self->{othermilp}->{$m}->{showsign} = "'<=";
			}
			elsif ($self->attr("eqtype", $m) == 3) {
				$self->{othermilp}->{$m}->{range} = 0 unless (defined $self->{othermilp}->{$m}->{range});
				$self->{othermilp}->{$m}->{showsign} = "'==";
			}
			elsif ($self->attr("eqtype", $m) == 2) {
				$self->{othermilp}->{$m}->{range} = 10**31 unless (defined $self->{othermilp}->{$m}->{range});
				$self->{othermilp}->{$m}->{showsign} = "'>=";
			} 
		}
	}
}

1;
