package MpmasNetwork;

use strict;
use warnings;
use Exporter;
use Storable qw(dclone);
use Data::Dumper;
use CtUtilities qw(queryhash extqueryhash);
use MpmasInputfile;
use MpmasInputBlock;
our @ISA = qw(MpmasInputfile);

sub filename {
	my $self = shift;
	return "Network".$self->file_suffix;
}

sub required {
	my $self = shift;
	return 1;
}
sub prepare_shared {

}

sub prepare_special {
	my $self = shift;	

	my $i = $self->argument;
	my $netw = MpmasInputBlock->new(3, 10);
	my $NN = $self->number_of_networkobjects;
	$netw->add_comment_row("INNOVATION NETWORK $i"); 
	$netw->add_row("","","Number of investment goods", "$NN");
	my @header = ("","Code","Description of investment object","Object ID","Innovation ID","Object type","Divisibility","Acquisition cost","Lifetime","Suitability to soil type","Minimum investment","Activity index in MILP","Constraint index in MILP","Permanent crop yield constraint","Right-hand-side value","Innovativeness","Share own capital","Interest rate on borrowed capital");
	if ($self->config_entry("COUNTRY") == 5 ) {
	      push @header, "Available until period";
	      push @header, "Inflation rate past";
	      push @header, "Min. age at simulation start";
	      push @header, "Max. age at simulation start";
	}
	push @header, "Object name";
	$netw->add_comment_row(@header);
	#loop over sorted network objects

	for my $no ($self->sorted_networkobjects){
		my $co = $self->networkobject($no);
		my @nettab;
		@nettab[0..2] = ("","$no",$co->get_attribute("name")); 
		for my $f (qw(oid innovid type	div acqcost lifetime terrain mininvest act con perm multiplier innovativeness eqshare irate) ){
			push @nettab, $co->get_attribute($f);
		}
		if ($self->config_entry("COUNTRY") == 5 ) {
		    push @nettab, $co->get_attribute("available_until_period");
		    push @nettab, $co->get_attribute("inflation_rate_past");
		    push @nettab, $co->get_attribute("minimum_age_at_simulation_start");
		    push @nettab, $co->get_attribute("maximum_age_at_simulation_start"); 
		}
		push @nettab, $co->get_attribute("oname");
		$netw->add_row(@nettab)
	}
	$self->add_block($netw);
		
}
1;
