package MpmasNetworkObject;
use strict;
use warnings;
use Exporter;
use Storable qw(dclone);
use Data::Dumper;
use MpmasQLModelElementAbstract;

our @ISA = qw(MpmasQLModelElementAbstract);

##class variables
my %existing_onames;

##implmentation of MpmasQLModelElements abstract methods
sub defaultclass {
	"asset"
}
sub list_of_default_fields { 
	my @array = qw(name innogrp type div acqcost lifetime terrain mininvest	act con perm multiplier	innovativeness	eqshare	irate landreq available_until_period inflation_rate_past minimum_age_at_simulation_start maximum_age_at_simulation_start);
	return \@array;
}
sub list_of_attribute_fields{
	my @array = qw(othermilp othermilp_subelements name description innogrp type div acqcost lifetime terrain mininvest act con perm multiplier innovativeness eqshare irate oname landreq oid available_until_period sex inflation_rate_past minimum_age_at_simulation_start maximum_age_at_simulation_start);
	return \@array;
}
sub list_of_attribute_stubs {
	my @array = qw();
	return \@array;
}
sub calculate_attributes {
	my $self = $_[0];
	my $oname = $self->{oname};
	if (not defined $oname) {
	     $oname  = $self->id;
	}
	if (length($oname) > 10) {
	     $oname = substr($oname,0,10);
	}
	if (exists $existing_onames{$oname}) {
	     $oname = substr($oname,0,5) . sprintf("%05d", scalar(keys(%existing_onames) ));
	}
	$existing_onames{$oname} = 1;
	$self->{oname} = $oname;
	
}
sub reset_existing_onames {
  undef %existing_onames ;
}

##additional class methods
sub set_oid {
	my $self = shift;
	my $var = shift;
	$self->{oid} = $var;
}
sub oid {
	my $self = shift;
	return 	$self->{oid};
}
sub set_con {
	my $self = shift;
	my $var = shift;
	$self->{con} = $var;
}
sub con {
	my $self = shift;
	return 	$self->{con};
}
sub set_act {
	my $self = shift;
	my $var = shift;
	$self->{act} = $var;
}
sub act {
	my $self = shift;
	return 	$self->{act};
}
sub set_perm {
	my $self = shift;
	my $var = shift;
	$self->{perm} = $var;
}
sub perm {
	my $self = shift;
	return 	$self->{perm};
}
sub set_type {
	my $self = shift;
	my $var = shift;
	$self->{type} = $var;
}
sub type {
	my $self = shift;
	return 	$self->{type};
}
sub set_innogrp {
	my $self = shift;
	my $var = shift;
	$self->{innogrp} = $var;
}
sub innogrp {
	my $self = shift;
	return 	$self->{innogrp};
}
sub set_innovid {
	my $self = shift;
	my $var = shift;
	$self->{innovid} = $var;
}
sub innovid {
	my $self = shift;
	return 	$self->{innovid};
}
sub set_srank {
	my $self = shift;
	my $var = shift;
	$self->{srank} = $var;
}
sub srank {
	my $self = shift;
	return 	$self->{srank};
}
sub set_network_row {
	my $self = shift;
	my $var = shift;
	$self->{NetworkRow} = $var;
}
sub network_row {
	my $self = shift;
	return 	$self->{NetworkRow};
}

sub set_ifnet {
	my $self = shift;
	my $var = shift;
	$self->{ifnet} = $var;
}
sub ifnet {
	my $self = shift;
	return 	$self->{ifnet};
}

1;
