package MpmasQLFieldDefinition;
use strict;
use warnings;
use Exporter;
use Storable qw(dclone);
use Data::Dumper;
use SimpleObject;
use MpmasQLClassDefinitionLanguage;
our @ISA = qw(SimpleObject);

sub id {
    
    return $_[0]->{id};
}
sub type {
    
    return $_[0]->{type};
}
sub fieldname {
    
    return $_[0]->{fieldname};
}
sub content {
    
    return $_[0]->{content};
}
sub set_id {
    $_[0]->{id} = $_[1];
}
sub set_type {
    $_[0]->{type} = $_[1];
}
sub set_fieldname {

    $_[0]->{fieldname} = $_[1];
}
sub set_content {
    $_[0]->{content} = $_[1];
}
sub is_a_list_field {
    return 1 if ($_[0]->{type} eq "list");
    return 0;
}
sub thisfor {
    return $_[0]->{thisfor}
}
sub set_thisfor {
    $_[0]->{thisfor} = $_[1];
}
sub transform {
    my $self = shift;
    my $curInstanceId = shift;
    my $curElementId = shift;
    my $thisby = shift;
    my $dyninfo = shift;
    my $specvars = shift||{};
    my $milplist = shift || (1);
    my $verbose = shift ||0;
    
    my  @new_untransformed_fields;

    if ($self->id =~ /^mult\d/ ){
	my $x = $self->fieldname;
	my $locvarhash = {(
		thisinst =>  $curInstanceId,
		thiselement => $curElementId,
		thisby => $thisby
		)};
	my %mergedlocvars = ( %$locvarhash , %$specvars);
	
	my @cf;
	eval{
		local $SIG{__WARN__}=sub{};	
		@cf = MpmasQLClassDefinitionLanguage->interprete($x, \%mergedlocvars); 
	};
	die "Error $@\n Instance: $curInstanceId, Element: ".$curElementId.", Field: $x\n" if $@;
	#@cf has nominally two dimensions, but dimensions actually used depend on return value of sub interprete
	#scalar return -> only $cf[0][0]
	#return of field list -> $cf[...][0] List of field names, $cf[...][1] List of #thisfor values
	if (defined $cf[0][0]) {
		for my $j (0..$#cf){
		    my $newfield = $self->create_copy;
		    $newfield->set_id($cf[$j][0]);
		    $newfield->set_fieldname($cf[$j][0]);
		    $newfield->set_thisfor($cf[$j][1]);
		    push @new_untransformed_fields, $newfield;
		}
	}
	return undef, \@new_untransformed_fields;
    }

    my %content_by_milp;
    my $x= $self->content;
    #Decide whether loop for several dynamic stages is necessary and start loop if necessary
    my $numdyn =  0;
    $numdyn = $dyninfo if ($x =~ /#thisdyn/);
    my @milps = (1);
    @milps = @$milplist if ($x =~ /#thismilp/);
    for my $thismilp (@milps) {
	    my $content;
	    for my $curDyn (0..$numdyn) {
		    my $locvarhash = { (
			    thisinst => $curInstanceId,
			    thiselement => $curElementId,
			    thisfield => $self->id,
			    thisby => $thisby,
			    thisfor => $self->thisfor,
			    thisdyn	=> $curDyn,
			    thismilp => $thismilp )};
		    my %mergedlocvars = ( %$locvarhash , %$specvars);
		    my @cfcont;
		    eval{
			    local $SIG{__WARN__}=sub{};
			    @cfcont = MpmasQLClassDefinitionLanguage->interprete($x, \%mergedlocvars);
		    };
		    die "Error $@\n Instance $curInstanceId, Element: ".$curElementId." Field: ".$self->id."\n" if $@;
		    print "Warning: Value for field ".$self->id." of instance $curInstanceId is an array!!! \n Only the first entry in the array is used for now. \n Value definitions may not result in arrays for one single field!.\n Maybe you forgot an aggregation function?\n" if ($#cfcont > 0 and not $self->is_a_list_field);

		    if ($self->is_a_list_field) {
			    my @array;
			    for my $i (@cfcont) {
				push @array, $i->[0];
			    }
			    if ($numdyn == 0) {
				    $content =  \@array;
			    }
			    else {
				    $content->{$curDyn} = \@array;
			    }
		    }
		    else {
			    if ($numdyn == 0) {
				    $content = $cfcont[0][0] || 0;
			    }
			    else {
				    $content->{$curDyn} = $cfcont[0][0];
			    }
		    }
	     }	#end of loop over dynamic sets $curDyn
    
     	    print " = (MILP $thismilp) $content\n" if ($verbose and not ref($content));
     	    print " = (MILP $thismilp)".ref($content)."\n" if ($verbose and ref($content));
	    $content_by_milp{$thismilp} = $content;
	 } #end of loop over milps
     return \%content_by_milp, \@new_untransformed_fields;
}
1;
